//__INSERT_LICENSE__
// $Id: rotacion.cpp,v 1.2 2004/04/05 16:05:56 mstorti Exp $

/* 
   COMIENZO DE DESCRIPCION 
   Escribir una funcion {\tt void ROTACION(queue<int> &C)}, el cual
   saca una cierta cantidad de enteros del frente de la cola C y los
   vuelve a insertar en fin de la cola, de tal manera que quede en el
   frente de cola un n\'umero par. Por ejemplo, si C = [1, 3, 5, 2, 4]
   entonces, despu\'es de {\tt rotacion(C)}, debe quedar C = [2, 4, 1, 3,
   5].
   Ejercicio tomado en el 1er parcial, 16/04/02.
   keywords: cola
   FIN DE DESCRIPCION 
*/

#include "./util.h"

using namespace std;

void rotacion(queue<int> &C) {
  while (true) {
    int w = C.front();
    if  (!(w % 2)) break;
    C.pop();
    C.push(w);
  }
}

int main() {
  for (int j=0; j<20; j++) {
    queue<int> C;
    int puso_par = 0,j=0;
    double ppar = 0.1;
    while (true) { 
      int w = 2*irand(20);
      if (drand()>ppar) w += 1;
      C.push(w);
      if (j++>20 && puso_par) break;
      if (!(w % 2)) puso_par = 1;
    }
    cout << "antes de rotar ";
    printq(C);
    rotacion(C);
    cout << "despues de rotar ";
    printq(C);
    cout << "-----------------------\n";
  }
}
