//__INSERT_LICENSE__
// $Id: imprinv.cpp,v 1.3 2004/04/05 23:59:54 mstorti Exp $

/* 
   COMIENZO DE DESCRIPCION
   
   Escriba una funcion `void imprinv(list<int> &L,list<int>::iterator
   p)' para imprimir de forma recursiva una lista invertida desde la
   posici\'on p hasta el final.  Se le da como dato el procedimiento a
   la primera posici\'on de la lista.  Esta version usa la unidad
   'u_listpi', es decir, listas de enteros por punteros y sin puntero
   a la celda final.
   [Ejercicio 3 del final del 14/02/2002.]
   keywords: lista

   FIN DE DESCRIPCION 
*/

#include <list>
#include <iostream>

using namespace std;

void imprinv(list<int> &L,list<int>::iterator p) {
  if (p==L.end()) return;
  list<int>::iterator q = p; 
  q++;
  imprinv(L,q);
  cout << *p << " ";
}

void imprinv(list<int> &L) { 
  imprinv(L,L.begin()); 
  cout << endl;
}

int main() {
  list<int> L;
  int v[] = {10,1,15,7,2,19,15,16,11,15,9,13,3,7,6,12,1,-1};
  int *vp = v;
  while (*vp!=-1) L.insert(L.end(),*vp++);
  imprinv(L);
}
