// $Id: interca.cpp,v 1.4 2004/04/05 16:14:00 mstorti Exp $
/*
  COMIENZO DE DESCRIPCION

  Escribir una funcion `void intercambia(list<int> &L);' que
  intercambia los elementos de L de tal forma que aquellos que estan en
  una posicion impar son intercambiados con el elemento en la posicion
  par inmediatamente siguiente. Es decir el primero es intercambiado con
  el segundo, el tercero con el cuarto y asi siguiendo. Si el numero de
  elementos es impar, entonces el ultimo elemento queda inalterado. Asi
  por ejemplo, si la L=(10 1 15 7 2 19 15 16 11 15 9 13 3 7 6 12 1)
  entonces despues de intercambia debemos tener L=(1 10 7 15 19 2 16 15
  15 11 13 9 7 3 12 6 1). 
  [Ejercicio tomado en el examen final de 9/5/2002]
  keywords: lista

  FIN DE DESCRIPCION
*/

#include <list>
#include <iostream>

using namespace std;

void intercambia(list<int> &L) {
  list<int>::iterator p = L.begin(), q;
  while (p!=L.end()) {
    int w = *p;
    p = L.erase(p);
    if (p!=L.end()) p++;
    L.insert(p,w);
  }
}

int main() {
  list<int> L;
  int v[] = {10,1,15,7,2,19,15,16,11,15,9,13,3,7,6,12,1,-1};
  int *vp = v;
  while (*vp!=-1) L.insert(L.end(),*vp++);
  intercambia(L);
  list<int>::iterator p = L.begin();
  while (p!=L.end()) cout << *p++ << " ";
  cout << endl;
}
