//__INSERT_LICENSE__
// $Id: ordenag.cpp,v 1.3 2004/04/05 23:59:54 mstorti Exp $

/*
  COMIENZO DE DESCRIPCION

  Escribir una funcion `void ordenag(list<int> &L,int m)' que, dada
  una lista L va ordenando sus elementos de a grupos de m
  elementos. Por ejemplo si m=5, entonces `ordenag' ordena los
  primeros 5 elementos entre si, despues los siguientes 5 elementos, y
  asi siguiendo. Si la longitud `N' de la lista no es un multiplo
  exacto de `m' elementos, entonces los ultimos `N mod m' elementos
  tambien deben ser ordenados entre si. Si L=(10 1 15 7 2 19 15 16 11
  15 9 13 3 7 6 12 1), entonces despues de `ordena_g(5)' debemos
  tener: L=(1 2 7 10 15 11 15 15 16 19 3 6 7 9 13 1 12).  
  [Tomado en el examen final del 5-Dic-2002].  
  keywords: lista

  FIN DE DESCRIPCION
*/

#include <list>
#include <iostream>
#include "./util.h"

using namespace std;

void ordenag(list<int> &L,int m) {
  list<int>::iterator p = L.begin();
  // int ordered = 0;
  // cout << "size of list: " << L.size() << endl;
  while (p!=L.end()) {
    for (int mm=m; mm>0; mm--) {
      // busca el elemento `*qmin' menor en el rango `[p,p+mm)'
      list<int>::iterator q = p, qmin = q;
      q++;
      for (int j=1; j<mm; j++) {
	if (q==L.end()) break;
	if (*q < *qmin) qmin = q;
	q++;
      }
      // Lo inserta en `p' y lo borra de `qmin'
      int w = *qmin;
      if (qmin != p) {
	L.erase(qmin);
	p = L.insert(p,w);
      }
      p++;
#if 0
      ordered++;
      cout << "ordered: " << ordered << ", ";
      printl(L);
#endif
      if (p==L.end()) break;
    }
  }
#if 1
  p = L.begin();
  int k = 0;
  while (p!=L.end()) {
    cout << *p++ << " ";
    if(!(++k % m)) cout << endl;
  }
  cout << endl;
#endif
}

int main() {
  list<int> L;
  for (int j=0; j<10; j++) {
    L.clear();
    randl(L,100,30.0);
    cout << "Antes de ordenar: ";
    printl(L);
    ordenag(L,5);
    cout << "Despues de ordenar: ";
    printl(L);
    cout << "-----------------\n";
  }
}
  
